import assignStyle from 'css-in-js-utils/lib/assignStyle';

import { isObject, arrayEach } from 'fela-utils';

function extendStyle(style, extension, extendPlugin) {
  // extend conditional style objects
  if (extension.hasOwnProperty('condition')) {
    if (extension.condition) {
      assignStyle(style, extendPlugin(extension.style));
    }
  } else {
    // extend basic style objects
    assignStyle(style, extension);
  }
}

function extend(style) {
  for (var property in style) {
    var value = style[property];

    if (property === 'extend') {
      var extensions = [].concat(value);

      arrayEach(extensions, function (extension) {
        return extendStyle(style, extension, extend);
      });
      delete style[property];
    } else if (isObject(value)) {
      // support nested extend as well
      style[property] = extend(value);
    }
  }

  return style;
}

export default (function () {
  return extend;
});